#include "ide.h"
#include "bash.h"


unsigned char ide_buffer[pio_laenge] @0x1000;



void ide_bindump(void)
{
  unsigned int t;
  
  for (t=0;t<pio_laenge;t+=2)
  {
    send_char(ide_buffer[t]);
    send_char(ide_buffer[t+1]);
  }
}

 


void ide_hexdump(void)
{
  unsigned char tbuffer[5];
  unsigned int t;
  
  for (t=0;t<pio_laenge;t+=2)
  {                              
    chartohex(ide_buffer[t],&tbuffer[0]);
    chartohex(ide_buffer[t+1],&tbuffer[2]); 
    send_string(tbuffer);               
    send_char(' ');
    if (t%32==0)
    {
      send_fstring("\n\r");
    }
  }
}




unsigned char ide_read_byte(unsigned int adresse)
{
  return(in(adresse));
}


unsigned int ide_read_word(unsigned int adresse)
{
  unsigned int ret;
  unsigned char tmp;
  
  tmp=in(adresse);
  ret=in(ide_latch_adress);
  ret=ret<<8;
  ret=ret|tmp;
  
  return(ret);
}


void ide_write_byte(unsigned int adresse,unsigned char byte)	//Schreibt ein byte an Adresse
{
  out(adresse,byte);
}


void ide_read_pio(unsigned char *buffer)
{  
  unsigned int temp,temp2,t;
  
  for (t=0;t<pio_laenge;t+=2)
  {  
    while(((ide_read_byte(ide_status_adress)&0x80)>=1)|((ide_read_byte(ide_status_adress)&0x40)==0))
    {
    	//evt. Timeoff einbauen
    }  
    temp=ide_read_word(ide_data_adress);
    
    temp2=temp&0x00FF;		//LOW-Byte abtrennen
    *buffer=temp2;		//LOW-Byte in Buffer schreiben
    buffer++;
    
    temp2=temp&0xFF00;		//High-Byte abtrennen
    temp2=temp2/256;
    *buffer=temp2;		//High-Byte in Buffer schreiben
    buffer++;  
  }
}


unsigned char ide_init(void)
{                                       
  unsigned int timeoff=0;
  unsigned char sec=0;
  //***Zuerst auf Platte warten
  send_fstring("\n\rWarte auf IDE:");
  while(((ide_read_byte(ide_status_adress)&0x80)>=1)|((ide_read_byte(ide_status_adress)&0x40)==0))
  {
    timeoff++;
    if (timeoff>44000)
    {
      timeoff=0;
      send_char('.');
      sec++;
      if (sec>40)
      {
        send_fstring(" fail");
        return(0);
      }
    }
  }                            
  send_fstring(" ok"); 

  //***Dann Device identifizieren
  send_fstring("\n\rIdentify Device:"); 
  
  while((ide_read_byte(ide_status_adress)&0x80)>=1)	//Auf bereitschaft warten
  {
  	//evt. Timeoff einbauen
  }
  
  ide_write_byte(ide_lba2427_adress,device);	//Zugriff auf Device festlegen
                                                                      	
  while(((ide_read_byte(ide_status_adress)&0x80)>=1)|(ide_read_byte(ide_status_adress)&0x40)==0)	//Auf bereitschaft warten
  {
  	//evt. Timeoff
  }                          
  ide_write_byte(ide_command_adress,identify_device);	//Befehl fr Identify-Device schreiben  
  ide_read_pio(ide_buffer);  
  send_fstring(" ok");  
  
  //***LAB-Support feststellen
  send_fstring("\n\rLBA supported:");
  if (ide_buffer[0x63]&0x02)
  {
    send_fstring(" ok");
  }
  else
  {
    send_fstring(" NO");
    return(0);
  }
  
  return(1);
}



unsigned char ide_read_sector(unsigned long int sector,unsigned char *buffer)
{ 
  unsigned long int temp;
  //unsigned char buffer2[10];
  if (buffer==0)
  {
    buffer=ide_buffer;
  }
  

  while((ide_read_byte(ide_status_adress)&0x80)>=1)	//Auf bereitschaft warten
  {
  	//evt. Timeoff einbauen
  }
  
  ide_write_byte(ide_lba2427_adress,device);	//Zugriff auf Device festlegen
                                                                      	
  while(((ide_read_byte(ide_status_adress)&0x80)>=1)|(ide_read_byte(ide_status_adress)&0x40)==0)	//Auf bereitschaft warten
  {
  	//evt. Timeoff
  }
  
  temp=sector&0x0F000000;	//Bytes 24-27
  temp=temp>>24;   

//  chartohex(temp,buffer2);

  temp=temp|device|0xE0;	//LBA & Device-Bit dazunehmen
  ide_write_byte(ide_lba2427_adress,temp);
  
  temp=sector&0x00FF0000;	//Bytes 16-23
  temp=temp>>16;
//  chartohex(temp,&buffer2[2]);
  ide_write_byte(ide_lba1623_adress,temp);
  
  temp=sector&0x0000FF00;	//Bytes 8-15
  temp=temp>>8;              
//  chartohex(temp,&buffer2[4]);
  ide_write_byte(ide_lba815_adress,temp);
  
  temp=sector&0x000000FF;	//Bytes 0-7
//  chartohex(temp,&buffer2[6]);
  ide_write_byte(ide_lba07_adress,temp);  
  
  ide_write_byte(ide_seccnt_adress,0x01);
  
  ide_write_byte(ide_command_adress,read);	//Befehl fr read-Device schreiben
  
  ide_read_pio(buffer);
  
//  send_fstring("\n\rRead sec: ");
//  send_string(buffer2);
  
  return(0);
}